import { checkIsDuplicated } from "../utils/checkDuplicated";
export default function useDynamicFields(formContext, fieldArray, fieldName) {
    var _a;
    var instanceRef = formContext.instanceRef, getValues = formContext.getValues;
    var append = fieldArray.append, remove = fieldArray.remove, fields = fieldArray.fields;
    var idx = Number((_a = instanceRef.current) === null || _a === void 0 ? void 0 : _a.name.split(".")[1]);
    var checkFieldValueDuplicated = function (alertMessage) {
        if (instanceRef.current === undefined)
            return;
        if (idx > 0 &&
            checkIsDuplicated(getValues("".concat(fieldName, ".").concat(idx)), getValues("".concat(fieldName)).slice(0, getValues("".concat(fieldName)).length - 1))) {
            alertMessage !== null && alertMessage !== void 0 ? alertMessage : alert(alertMessage);
            instanceRef.current.autofocus = true;
            return;
        }
    };
    var lockDynamicField = function () {
        if (instanceRef.current === undefined)
            return;
        instanceRef.current.readOnly = true;
    };
    var appendDynamicField = function (fieldLimit) {
        if (fieldLimit && fields.length > fieldLimit)
            return;
        append("");
    };
    var handleKeyDownEnter = function (e, handleFieldCallbacks) {
        if (instanceRef.current === undefined)
            return;
        if (e.code === "Enter") {
            handleFieldCallbacks === null || handleFieldCallbacks === void 0 ? void 0 : handleFieldCallbacks.forEach(function (callback) {
                callback === null || callback === void 0 ? void 0 : callback();
            });
        }
    };
    var deleteDynamicField = function (e, idx, appendNewFiled) {
        var deleteTarget = e.target;
        deleteTarget.style.display = "none";
        remove(idx);
        appendNewFiled !== null && appendNewFiled !== void 0 ? appendNewFiled : append("");
    };
    var activeField = function () {
        if (instanceRef.current === undefined)
            return;
        if (instanceRef.current.value === "") {
            instanceRef.current.readOnly = false;
        }
    };
    var clickOutside = function (e, ignoredTarget, handleFieldCallbacks) {
        if (instanceRef.current === undefined)
            return;
        var target = e.target;
        if (ignoredTarget && Number(target.dataset.idx) === idx)
            return;
        handleFieldCallbacks === null || handleFieldCallbacks === void 0 ? void 0 : handleFieldCallbacks.forEach(function (callback) {
            callback === null || callback === void 0 ? void 0 : callback();
        });
    };
    return {
        handleKeyDownEnter: handleKeyDownEnter,
        checkFieldValueDuplicated: checkFieldValueDuplicated,
        lockDynamicField: lockDynamicField,
        appendDynamicField: appendDynamicField,
        deleteDynamicField: deleteDynamicField,
        activeField: activeField,
        clickOutside: clickOutside,
    };
}
